// WlanControlDlg.cpp : ʵļ
//

#include "stdafx.h"
#include "WlanControl.h"
#include "WlanControlDlg.h"
#include ".\wlancontroldlg.h"
#include "HyperLink.h"




#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// Ӧó򡰹ڡ˵ CAboutDlg Ի

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Ի
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV ֧

// ʵ
protected:
	DECLARE_MESSAGE_MAP()
public:
	CHyperLink m_Link;
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_STATIC_LINK, m_Link);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CWlanControlDlg Ի



CWlanControlDlg::CWlanControlDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CWlanControlDlg::IDD, pParent)
	, m_strUser(_T(""))
	, m_strPass(_T(""))
	, m_strLog(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWlanControlDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_USER, m_strUser);
	DDX_Text(pDX, IDC_EDIT_PASS, m_strPass);
	DDX_Control(pDX, IDC_BUTTON_LOGINOUT, m_btnLoginOut);
	DDX_Text(pDX, IDC_EDIT_LOG, m_strLog);
}

BEGIN_MESSAGE_MAP(CWlanControlDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_LOGINOUT, OnBnClickedButtonLoginOut)
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_MESSAGE(WM_NOTIFYICON,OnNotifyIcon)
	ON_MESSAGE(WM_RESTORE,OnRestore)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_CHECK_SAVE, &CWlanControlDlg::OnBnClickedCheckSave)
END_MESSAGE_MAP()


// CWlanControlDlg Ϣ

BOOL CWlanControlDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	int nOnlineSeconds=AfxGetApp()->GetProfileInt("Login","nOnlineSeconds",0);
	time_t t=nOnlineSeconds;
	CTimeSpan span(t);
	CString strText=span.Format( "ʱ: %D,%HСʱ,%M,%S.");
	SetDlgItemText(IDC_STATIC_ONLINE,strText);

	// \...\˵ӵϵͳ˵С

	// IDM_ABOUTBOX ϵͳΧڡ
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		pSysMenu->AppendMenu(MF_STRING,IDM_MENU_EXIT,"˳(Exit)");
		
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	

	// ô˶ԻͼꡣӦóڲǶԻʱܽԶ
	//  ִд˲
	SetIcon(m_hIcon, TRUE);			// ôͼ
	SetIcon(m_hIcon, FALSE);		// Сͼ

	SetTimer(1,10,NULL);

	// ͼϵͳ
	NOTIFYICONDATA nd;
	nd.cbSize = sizeof (NOTIFYICONDATA);
	nd.hWnd = m_hWnd;
	nd.uID = IDR_MAINFRAME;
	nd.uFlags = NIF_ICON|NIF_MESSAGE|NIF_TIP;
	nd.uCallbackMessage = WM_NOTIFYICON;
	nd.hIcon = m_hIcon;//ʹõͼ
	strcpy_s(nd.szTip, "CMCC½");
	Shell_NotifyIcon(NIM_ADD, &nd);
	
	return TRUE;  // ˿ؼĽ㣬򷵻 TRUE
}

void CWlanControlDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else if ((nID&0xFFF0) == SC_MINIMIZE)
		this->ShowWindow(SW_HIDE);

	else if ((nID&0xFFF0) == SC_MAXIMIZE)
		return;
	else if (nID == IDM_MENU_EXIT)
	{
		EndDialog(0);
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

LRESULT CWlanControlDlg::OnRestore(WPARAM wParam, LPARAM lParam)
{
	this->ShowWindow(SW_SHOW);
	this->SetWindowPos(&wndTop,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);

	return 0;
}

LRESULT CWlanControlDlg::OnNotifyIcon(WPARAM wParam, LPARAM lParam)
{
	// Ӧͼϵĵ
	if (wParam == IDR_MAINFRAME)
	{       
		if (lParam == WM_LBUTTONDBLCLK)
		{
			this->ShowWindow(SW_SHOW);
			this->SetWindowPos(&wndTop,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
		}
		else if (lParam == WM_RBUTTONDOWN)
		{
			CPoint pos;
			GetCursorPos(&pos);

			CMenu menu;
			menu.CreatePopupMenu();
			menu.AppendMenu(MF_STRING,IDM_MENU_RESTORE,"ԭ(Restore)");
			menu.AppendMenu(MF_STRING,IDM_MENU_EXIT,"˳(Exit)");
			menu.AppendMenu(MF_SEPARATOR);
			menu.AppendMenu(MF_STRING,IDM_ABOUTBOX,"(About)");

			::SetForegroundWindow(m_hWnd);
			//TrackPopupMenu˵,˵ʧ
			menu.TrackPopupMenu(TPM_LEFTALIGN|TPM_RIGHTBUTTON,pos.x,pos.y,AfxGetMainWnd());
		}
	}
	return 0;
}

BOOL CWlanControlDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	WORD Id=LOWORD(wParam);
	if (Id==IDM_MENU_RESTORE)
	{
		this->ShowWindow(SW_SHOW);
		this->SetWindowPos(&wndTop,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);
	}
	else if (Id==IDM_MENU_EXIT)
	{
		CString strBtnName;
		GetDlgItemText(IDC_BUTTON_LOGINOUT,strBtnName);
		if (strBtnName=="")
		{
			EndDialog(0);
		}
		else
		{
			AfxMessageBox("ߣִ˳");
		}
	}
	else if (Id==IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	return CDialog::OnCommand(wParam, lParam);
}


// ԻСťҪĴ
//  Ƹͼꡣʹĵ/ͼģ͵ MFC Ӧó
//  ⽫ɿԶɡ

void CWlanControlDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ڻƵ豸

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// ʹͼڹо
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ͼ
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

//û϶Сʱϵͳô˺ȡùʾ
HCURSOR CWlanControlDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CWlanControlDlg::OnBnClickedButtonLoginOut()
{
	CHttpRequestWlan wlan(this);
	GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(FALSE);

	CString strBtnName;
	GetDlgItemText(IDC_BUTTON_LOGINOUT,strBtnName);
	if (strBtnName=="")
	{
		m_strLog="";
		UpdateData(FALSE);

		Sleep(500);
		if (wlan.Logout())
		{
			KillTimer(2);
			AfxGetApp()->WriteProfileString("Login","sLogoutAction","");
			SetDlgItemText(IDC_BUTTON_LOGINOUT,"");
		}
		GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(TRUE);
		return;
	}
	else if (strBtnName=="")
	{
		UpdateData(TRUE);
		m_strLog="";
		UpdateData(FALSE);

		UpdateData(TRUE);
		if(m_strUser.IsEmpty()||m_strPass.IsEmpty())
		{
			AfxMessageBox("û룡");
			GetDlgItem(IDC_EDIT_USER)->SetFocus();
			GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(TRUE);
			return;
		}

		AfxGetApp()->WriteProfileString("User","UserName",m_strUser);
		AfxGetApp()->WriteProfileString("User","PassWord",m_strPass);

		if (wlan.IsLogin())
		{
			AfxMessageBox("Ѿߣظ¼!");
			GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(TRUE);
			return;
		}

		if (wlan.Login(m_strUser.GetBuffer(),m_strPass.GetBuffer()))
		{
			SetTimer(2,1000,NULL);
			SetDlgItemText(IDC_BUTTON_LOGINOUT,"");	
		}
		m_strUser.ReleaseBuffer();
		m_strPass.ReleaseBuffer();

	}

	GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(TRUE);
}

void CWlanControlDlg::OnTimer(UINT_PTR nIDEvent)
{
	CWinApp* pApp=AfxGetApp();
	if (nIDEvent == 1)
	{
		// TODO: ڴϢ/Ĭֵ
		KillTimer(1);

		m_strUser=AfxGetApp()->GetProfileString("User","UserName");
		m_strPass=AfxGetApp()->GetProfileString("User","PassWord");
		BOOL bSave=(BOOL)AfxGetApp()->GetProfileInt("Debug","bSaveRequestLog",0);
		((CButton*)GetDlgItem(IDC_CHECK_SAVE))->SetCheck(bSave);

		UpdateData(FALSE);
		RedrawWindow();

		
		CHttpRequestWlan wlan(this);
		if (wlan.IsLogin())
		{
			SetDlgItemText(IDC_BUTTON_LOGINOUT,"");
			string sLogoutAction=pApp->GetProfileString("Login","sLogoutAction");
			if (sLogoutAction.empty())
			{
				m_strLog+="ܲʹôߵģʹôߣ";
				UpdateData(FALSE);
				//GetDlgItem(IDC_BUTTON_LOGINOUT)->EnableWindow(FALSE);
			}

			SetTimer(2,1000,NULL);
		}
	}
	else if (nIDEvent==2)
	{
		int nOnlineSeconds=pApp->GetProfileInt("Login","nOnlineSeconds",0);
		nOnlineSeconds++;
		pApp->WriteProfileInt("Login","nOnlineSeconds",nOnlineSeconds);

		time_t t=nOnlineSeconds;
		CTimeSpan span(t);
		CString strText=span.Format( "ʱ: %D,%HСʱ,%M,%S.");
		SetDlgItemText(IDC_STATIC_ONLINE,strText);
	}
	CDialog::OnTimer(nIDEvent);
}

void CWlanControlDlg::OnDestroy()
{
	CDialog::OnDestroy();

	NOTIFYICONDATA nd;
	nd.cbSize   = sizeof (NOTIFYICONDATA);
	nd.hWnd = m_hWnd;
	nd.uID = IDR_MAINFRAME;    
	Shell_NotifyIcon(NIM_DELETE,&nd);

	// TODO: ڴ˴Ϣ
}

void CWlanControlDlg::OnClose()
{
	// TODO: ڴϢ/Ĭֵ
	CString strBtnName;
	GetDlgItemText(IDC_BUTTON_LOGINOUT,strBtnName);
	if (strBtnName=="")
	{
		PostMessage(WM_SYSCOMMAND,SC_MINIMIZE);
		return;
	}

	CDialog::OnClose();
}


void CWlanControlDlg::OnBnClickedCheckSave()
{
	UpdateData(TRUE);
	AfxGetApp()->WriteProfileInt("Debug","bSaveRequestLog",((CButton*)GetDlgItem(IDC_CHECK_SAVE))->GetCheck()==1);
}
