#pragma once

#include <curl/curl.h>
#include <string>
using namespace std;

class CWlanControlDlg;
class CHttpRequest
{
public:
	CHttpRequest(void);
	~CHttpRequest(void);
	string& Post(string strUrl,string strData,string sRefer="");	
	string& Get(string strUrl);
private:
	CURL *m_pUrlHandle;
	string m_strHtml;
	int iRequestCount;
private:
	void ResetUrlOption();
	void write_debugInfo(string& s);
private:
	static size_t write_data(void *buffer, size_t size, size_t nmemb, void *userp);
};

class CHttpRequestWlan:public CHttpRequest
{
public:
	CHttpRequestWlan(CWlanControlDlg* pDlg);
	bool Login(string user,string pass);
	bool Logout();
	bool IsLogin();
private:
	string CutString(string& str,string strLeft,string strRight);
	CTime FromTimeString(CString pm_TimeString);
	void AddLog(string strLog);
	CWlanControlDlg* m_pDlg;
};